/*
--------------------------------------------------------------------------------------
    VisualApplication v. 0.3
    Copyright (C) 2008 andbad
    andbad@iol.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
--------------------------------------------------------------------------------------
*/
#define ND_NOT_MAIN_SOURCE

#include <nanodesktop.h>
#include <stdio.h>
#include <math.h>

//Dichiarazione delle funzioni globali
ndint64 TheCloseWndCallback (char WndHandle, ndint64 WndInfoField);
ndint64 AboutVisualApplication(char WndHandle);

//Variabili del programma
int CharCounter=0, CharCounter2=0, i,YouCanExit,real=0, OpA=0, OpB=0,LastNum, AnalogMouse;
float OpAF=0, OpBF=0;
char Display[18], Operatore;


/*
    ---------------------------------------------------------------------------
    Funzioni di utilità
    ---------------------------------------------------------------------------
*/  
void PrintDisplay(char WndHandle)
//Funzione che stampa sul display il contenuto dell'array Display
{
     int j=0;
     ndWS_DrawRectangle (10, 10, 205, 47, COLOR_BLUE, COLOR_WHITE, WndHandle, NORENDER);
     for (i=CharCounter; i>0; i--) 
     {
         ndWS_GrPrintLn (185-i*10, 30, COLOR_WHITE, COLOR_BLUE, WndHandle, NDKEY_FONT (3) | NORENDER, "%c", Display[j]);
         j++;
     };
     XWindowRender(WndHandle);
}

void PrintRes(float res, char WndHandle)
//Funzione che stampa s display il risultato di una operazione
{
     ndWS_DrawRectangle (10, 10, 205, 47, COLOR_BLUE, COLOR_WHITE, WndHandle, NORENDER);
     ndWS_GrPrintLn (25, 15, COLOR_WHITE, COLOR_BLUE, WndHandle, NDKEY_FONT (3) | NORENDER, "Result: %f", res);
     XWindowRender(WndHandle);
}


/*
    ---------------------------------------------------------------------------
    Callback dei pulsanti
    ---------------------------------------------------------------------------
*/  
ndint64 ButtonNumer (char *StringID, ndint64 InfoField, char WndHandle) 
{
    switch (InfoField)
    {
           case 00000001: LastNum=1; break;
           case 00000002: LastNum=2; break;
           case 00000003: LastNum=3; break;
           case 00000004: LastNum=4; break;
           case 00000005: LastNum=5; break;
           case 00000006: LastNum=6; break;
           case 00000007: LastNum=7; break;
           case 00000010: LastNum=8; break;
           case 00000011: LastNum=9; break;
           case 00000000: LastNum=0; break;
    }            
    Display[CharCounter]=48+LastNum;  //per momorizzare il simbolo dell'operazione nell'array Display
    CharCounter++;
    if (real==0) OpA=OpA*10+LastNum; //aggiorno il valore dell'operatore in caso di numeri interi
    else OpAF=(LastNum+OpAF)/10;     //aggiorno il valore dell'operatore in caso di numeri reali
    
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
    // Funzione di Debug che mostra il contenuto della variabile OpAF
    // ndWS_GrPrintLn (25, 30, COLOR_WHITE, COLOR_BLUE, WndHandle, NDKEY_FONT (3) | RENDER, "Test %f",OpAF);
}

ndint64 ButtonDot (char *StringID, ndint64 InfoField, char WndHandle) 
{
    Display[CharCounter]=',';   
    CharCounter++;
    real=1;
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonEQ (char *StringID, ndint64 InfoField, char WndHandle) 
//Callback del pulsante "=" che dev'essere premuto per eseguire l'operazione.
{
    float res=0;
    OpAF=OpA+OpAF;
    switch (Operatore) 
    {
           case '+': res=OpBF+OpAF; break;
           case '-': res=OpBF-OpAF; break;
           case '/': res=OpBF/OpAF; break;
           case '*': res=OpBF*OpAF; break;
           case '%': res=OpBF/100*OpAF; break;
           case '^': res=OpBF; if (OpA==0) OpA=2; for (;OpA>1;OpA--) res=res*OpBF; break;
           case ']': res=sqrt(OpBF); break;
    }
    PrintRes(res,WndHandle);
    OpA=res;
    OpAF=res-OpA;
    OpB=0;
    OpBF=0;
    res=0;
    real=0;
    Operatore=0;
    CharCounter=0;
    ndHAL_Delay(0.15);
}

ndint64 ButtonPiu (char *StringID, ndint64 InfoField, char WndHandle) 
{
    Operatore='+';
    Display[CharCounter]=Operatore;
    CharCounter++;
    OpBF=OpA+OpAF;
    OpAF=0;
    OpA=0;
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonMeno (char *StringID, ndint64 InfoField, char WndHandle) 
{
    Operatore='-';
    Display[CharCounter]=Operatore;
    CharCounter++;
    OpBF=OpA+OpAF;
    OpAF=0;
    OpA=0;
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonPer (char *StringID, ndint64 InfoField, char WndHandle) 
{
    Operatore='*';
    Display[CharCounter]=Operatore;
    CharCounter++;
    OpBF=OpA+OpAF;
    OpAF=0;
    OpA=0;
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonDiviso (char *StringID, ndint64 InfoField, char WndHandle) 
{
    Operatore='/';
    Display[CharCounter]=Operatore;
    CharCounter++;
    OpBF=OpA+OpAF;
    OpAF=0;
    OpA=0;
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonPercento (char *StringID, ndint64 InfoField, char WndHandle) 
{
    Operatore='%';
    Display[CharCounter]='%';
    CharCounter++;
    OpBF=OpA+OpAF;
    OpAF=0;
    OpA=0;
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonQuadrato (char *StringID, ndint64 InfoField, char WndHandle) 
{
    Operatore='^';
    Display[CharCounter]='^';
    CharCounter++;
    OpBF=OpA+OpAF;
    OpAF=0;
    OpA=0;
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonDel (char *StringID, ndint64 InfoField, char WndHandle) 
{
    if (CharCounter!=0)
    {
       if (Display[CharCounter-1]>'0')
       {
          if (Display[CharCounter-1]<'9') 
          {
              if (real==0) OpA=(OpA-LastNum)/10;
              else OpAF=(OpAF-LastNum)*10;
          };
       }        
       else 
       {
            if (Display[CharCounter]=='.') real==0;
            else Operatore==0;
       };
       CharCounter--;
    };   
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonC (char *StringID, ndint64 InfoField, char WndHandle) 
{
    OpAF=0;
    OpA=0;
    OpBF=0;
    OpB=0;
    real=0;
    CharCounter=0;
    ndWS_DrawRectangle (10, 10, 205, 47, COLOR_BLUE, COLOR_WHITE, WndHandle, NORENDER);
    XWindowRender(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonCE (char *StringID, ndint64 InfoField, char WndHandle) 
{
    OpA=0;
    OpAF=0;
    //CharCounter--;
    for (i=0; i!=1; CharCounter--)
    { 
        if (Display[CharCounter]<'0') i=1;
        if (Display[CharCounter]>'9') i=1;
        if (CharCounter==0) i=1;
    };              
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}

ndint64 ButtonRadice (char *StringID, ndint64 InfoField, char WndHandle) 
{
    Operatore=']';
    Display[CharCounter]=']';
    CharCounter++;
    OpBF=OpA+OpAF;
    OpAF=0;
    OpA=0;
    PrintDisplay(WndHandle);
    ndHAL_Delay(0.15);
}


/*
    ---------------------------------------------------------------------------
    Interfaccia grafica
    ---------------------------------------------------------------------------
*/ 
//Struttura del WinMenu
void WinMenuCalc(char WndHandle)
{
     ndWMENU_DefineMenuItem (WndHandle, "File", "File", 0, 0, NORENDER);
         ndWMENU_DefineMenuItem (WndHandle, "File.Quit", "Quit", 0, &TheCloseWndCallback, NORENDER);
     ndWMENU_DefineMenuItem (WndHandle, "?", "?", ND_CALLBACK_IN_NEW_CONTEXT, &AboutVisualApplication, NORENDER);    
}

void InterfacciaVisualCalc(int WndHandle)
//Interfaccia (richiama anche i WinMenu)
{
     //Carico i WInMenu
     WinMenuCalc(WndHandle);

     //Creo i pulsanti
    ndCTRL_CreateButton ( 10, 50, 40, 80, WndHandle, "Button7","7", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000007, NORENDER );
    ndCTRL_CreateButton ( 43, 50, 73, 80, WndHandle, "Button8","8", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000010, NORENDER );
    ndCTRL_CreateButton ( 76, 50, 106, 80, WndHandle, "Button9","9", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000011, NORENDER );
    ndCTRL_CreateButton ( 10, 83, 40, 113, WndHandle, "Button4","4", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000004, NORENDER );
    ndCTRL_CreateButton ( 43, 83, 74, 113, WndHandle, "Button5","5", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000005, NORENDER );
    ndCTRL_CreateButton ( 76, 83, 106, 113, WndHandle, "Button6","6", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000006, NORENDER );
    ndCTRL_CreateButton ( 10, 116, 40, 146, WndHandle, "Button1","1", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000001, NORENDER );
    ndCTRL_CreateButton ( 43, 116, 73, 146, WndHandle, "Button2","2", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000002, NORENDER );
    ndCTRL_CreateButton ( 76, 116, 106, 146, WndHandle, "Button3","3", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000003, NORENDER );
    ndCTRL_CreateButton ( 10, 149, 40, 179, WndHandle, "Button0","0", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonNumer, 00000000, NORENDER );
    ndCTRL_CreateButton ( 43, 149, 73, 179, WndHandle, "Button,",",", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonDot, 0, NORENDER );
    ndCTRL_CreateButton ( 76, 149, 106, 179, WndHandle, "Button=","=", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonEQ, 0, NORENDER );
    ndCTRL_CreateButton ( 109, 50, 139, 113, WndHandle, "Button+","+", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonPiu, 0, NORENDER );
    ndCTRL_CreateButton ( 109, 116, 139, 179, WndHandle, "Button-","-", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonMeno, 0, NORENDER );
    ndCTRL_CreateButton ( 143, 50, 172, 80, WndHandle, "ButtonX","X", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonPer, 0, NORENDER );
    ndCTRL_CreateButton ( 143, 83, 172, 113, WndHandle, "Button/","/", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonDiviso, 0, NORENDER );
    ndCTRL_CreateButton ( 143, 116, 172, 146, WndHandle, "Button%","%", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonPercento, 0, NORENDER );
    ndCTRL_CreateButton ( 143, 149, 172, 179, WndHandle, "Button^2","^2", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonQuadrato, 0, NORENDER );
    ndCTRL_CreateButton ( 175, 50, 205, 80, WndHandle, "Button<-","<-", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonDel, 0, NORENDER );
    ndCTRL_CreateButton ( 175, 83, 205, 113, WndHandle, "ButtonC","C", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonC, 0, NORENDER );
    ndCTRL_CreateButton ( 175, 116, 205, 146, WndHandle, "ButtonCE","CE", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonCE, 0, NORENDER );
    ndCTRL_CreateButton ( 175, 149, 205, 179, WndHandle, "ButtonSqR","SqR", "",COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,ND_BUTTON_ROUNDED | NDKEY_FONT (3), &ButtonRadice, 0, NORENDER );
    
    //Creo il rettangolo per il display
    ndWS_DrawRectangle (10, 10, 205, 47, COLOR_BLUE, COLOR_WHITE, WndHandle, NORENDER);

    XWindowRender(WndHandle);
}


/*
    ---------------------------------------------------------------------------
    Main
    ---------------------------------------------------------------------------
*/ 

void VisualCalc(char *StringID, ndint64 InfoField, char WndHandle)
{
    //Creazione della finestra
    char WndHandleLocal;
    ndLP_MinimizeWindow (WndHandle);
    WndHandleLocal=ndLP_CreateWindow (2, 2, 220, 230, "VisualCalculator", COLOR_WHITE, COLOR_BLUE,COLOR_LBLUE, COLOR_WHITE, NO_RESIZEABLE|MENUSUPPORTED);
    ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandleLocal);    
    ndLP_PutWindowInFirstPlane(WndHandleLocal);
    ndLP_MaximizeWindow (WndHandleLocal);
    
    InterfacciaVisualCalc(WndHandleLocal);
    ndHAL_MouseControlledByAnalog(AnalogMouse);
    ndProvideMeTheMouse_Until (&YouCanExit, ND_IS_EQUAL, 1, 0, 0); 
    
    //Uscita dall'applicazione e ritorno alla finestra base
    YouCanExit=0;
    ndHAL_Delay(0.5);
    ndLP_DestroyWindow(WndHandleLocal);
    ndLP_MaximizeWindow(WndHandle);
};
