/*
--------------------------------------------------------------------------------------
    VisualApplication v. 0.3
    Copyright (C) 2008 andbad
    andbad@iol.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
--------------------------------------------------------------------------------------
*/
#define ND_NOT_MAIN_SOURCE

#include <nanodesktop.h>
#include <stdio.h>

//Dichiarazione delle funzioni globali
ndint64 TheCloseWndCallback (char WndHandle, ndint64 WndInfoField);
ndint64 AboutVisualApplication(char WndHandle);

//Variabili del programma
int YouCanExit,MP3Option=0,ErrRep=0, TBoxHandle,WndDialogHandle, AutoRew_CtrVariable=1, AnalogMouse;
int BtnHandle[5];
int ChannelUsed=0, SSD=0,TotalSamples=100, AutoRew=ND_PLAY_AUTOREWIND,Volume=40, Bal=5;
char FileChoosen[255],WndHandleVisualMP3,NameFile[255],PathFile[255],ExtFile[4];
struct ndMediaObj_Type ndMediaObj;
struct ndImage_Type TypeFile,ButtonImage;

//Variabili per il caricamento delle immagini dei pulsanti da un NTF Array
extern unsigned short int TypeFileWAV,TypeFileMP3,NoFile,play, pause,stop,ffw,rew; 

/*
    ---------------------------------------------------------------------------
    Callback di utilit.
    ---------------------------------------------------------------------------
*/

int MediaCallback (ndint64 InfoField, struct ndMediaObj_Type *ndMediaObj, int NrSample, int HH, int MM, int SS)
//Callback che viene richiamata ogni volta che viene decodificato un frame audio
{
    sceKernelChangeThreadPriority (sceKernelGetThreadId(), 2);
    if (SS!=SSD) //Necessario per eseguire solo saltuariamente la callback, per mantenere buone prestazioni.
    {
	    char SSC[4]="", MMC[4]="", HHC[4]="";
        if (SS<10) 
	    {
           char temp[2]="";
           _itoa(SS,&temp,10);
           strncpy(&SSC, "0",1);
           strcat(&SSC,&temp);
        }
	    else _itoa(SS,&SSC,10);
	    
	    if (MM<10) 
        {
           char temp[2]="";
           _itoa(MM,&temp,10);
	       strncpy(&MMC, "0",1);
	       strcat(&MMC,&temp);
        }
	    else _itoa(MM,&MMC,10);
        
	    if (HH<10) 
	    {
           char temp[2]="";
           _itoa(HH,&temp,10);
	       strncpy(&HHC, "0",1);
	       strcat(&HHC,&temp);
        }
        else _itoa(HH,&HHC,10);
        
        ndWS_GrPrintLn (145, 42, COLOR_WHITE, COLOR_BLUE, WndHandleVisualMP3, NDKEY_FONT (1) | RENDER, "%s:%s:%s",HHC,MMC,SSC);

	    ndTBAR_DrawProgressBar (12, 131, 312, 150, NrSample, 0,TotalSamples, COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, PBAR_NOT_LABEL, WndHandleVisualMP3, RENDER);		//Aggiorna la progress bar in base al numero di sample eseguiti.
        SSD=SS;      
    }
};

static void AutoRew_Callback (int ActualValue, char *StringID, int CBoxHandle, char WndHandle)
//Callback della opzione AutoRewind
{
     ndHAL_MEDIA_Pause(&ndMediaObj);
     switch (ActualValue)
     {
            case 0: AutoRew=0; break;
            case 1: AutoRew=ND_PLAY_AUTOREWIND; break;
     }
     ndHAL_MEDIA_Play(&ndMediaObj,AutoRew);
}



/*
    ---------------------------------------------------------------------------
    Callback di pulsanti e elementi grafici vari
    ---------------------------------------------------------------------------
*/
ndint64 OpenButtonVisualMP3(char *StringID, ndint64 InfoField, char WndHandleVisualMP3)
//Callback del pulsante OpenButton
{   
    int i;
    do
    {
        //Richiamo il file manager
        FileManager ("Choose a file", 0, 0, &FileChoosen);
        
        //Carico il file scelto nel FileManager
        ErrRep=ndHAL_MEDIA_LoadFile (&FileChoosen, ChannelUsed, &ndMediaObj, &MediaCallback, 0);
                 
        if (ErrRep!=0) printf ("Failed to load audio file. Error reported %d \n", -ErrRep);
    } while (ErrRep!=0);
    
    //Aumento il contatore del canale audio utilizzato
    ChannelUsed++;
    
    //Carico l'immagine adatta al tipo di file
    ndIMG_InitImage (&TypeFile);
    if (ndMediaObj.Type==MEDIA_TYPE_MP3) 
    {
        ndIMG_LoadImageFromNDFArray (&TypeFile, 51, 51, &TypeFileMP3, NDMGKNB);
        TotalSamples=ndHAL_MEDIA_GetNrSamples(&ndMediaObj);
    }  
    else 
    {
         ndIMG_LoadImageFromNDFArray (&TypeFile, 51, 51, &TypeFileWAV, NDMGKNB);
         TotalSamples=ndMediaObj.WAV_SamplesInTotal;
    };
    ndIMG_ShowImage (&TypeFile, 261, 43, WndHandleVisualMP3, NORENDER);
    
    for (i=1; i<=5; i++) ndCTRL_DeInhibitButton (BtnHandle[i], WndHandleVisualMP3, NORENDER);
    
    //Scrivo il nome del file sull'interfaccia
    fssSplitNameFile(ndMediaObj.NameFile,PathFile,NameFile,ExtFile);
    strncpy ( ndTBOX_GetRowAddr (0, TBoxHandle, WndHandleVisualMP3), NameFile,strlen(NameFile));
    ndTBOX_TextAreaUpdate (TBoxHandle, WndHandleVisualMP3, NORENDER);
    
    XWindowRender(WndHandleVisualMP3);
    return 0;
}

ndint64 ButtonVisualMP3 (char *StringID, ndint64 InfoField, char WndHandleVisualMP3)
//Callback dei pulsanti Play, Stop, Pause, Rew e FFW 
{
       switch (InfoField)
       {
           case 0000000: ndHAL_MEDIA_Play(&ndMediaObj, AutoRew); break;
           case 0000001: 
           {     
                ndHAL_MEDIA_Stop(&ndMediaObj);
                ndHAL_MEDIA_GoToSample (&ndMediaObj, 0);	//Necessario per riportare la riproduzione all'inizio del file
                ndWS_GrPrintLn (145, 42, COLOR_WHITE, COLOR_BLUE, WndHandleVisualMP3, NDKEY_FONT (1) | NORENDER, "00:00:00");
                ndTBAR_DrawProgressBar (12, 131, 312, 150, 0, 0,100, COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, PBAR_NOT_LABEL, WndHandleVisualMP3, NORENDER); 
                XWindowRender(WndHandleVisualMP3); break;
           };     
           case 0000002: ndHAL_MEDIA_Pause(&ndMediaObj); break;
           case 0000003: 
           {
                //ndHAL_MEDIA_Pause(&ndMediaObj);
		        //ndHAL_Delay(0.15);
                if (ndMediaObj.Type==MEDIA_TYPE_MP3) ndHAL_MEDIA_GoToSample(&ndMediaObj, ndMediaObj.MP3_SamplesDecoded+100000);
                else ndHAL_MEDIA_GoToSample(&ndMediaObj, ndMediaObj.WAV_SamplesDecoded+100000);
                //ndHAL_Delay(0.15);
                //ndHAL_MEDIA_Play(&ndMediaObj, AutoRew);
                break;
           };
           case 00000004: 
           {
                //ndHAL_MEDIA_Pause(&ndMediaObj);
		        //ndHAL_Delay(0.15);
                if (ndMediaObj.Type==MEDIA_TYPE_MP3) ndHAL_MEDIA_GoToSample(&ndMediaObj, ndMediaObj.MP3_SamplesDecoded-100000);
                else ndHAL_MEDIA_GoToSample(&ndMediaObj, ndMediaObj.WAV_SamplesDecoded-100000);
                //ndHAL_Delay(0.15);
                //ndHAL_MEDIA_Play(&ndMediaObj, AutoRew);
                break;
           };
       };
       //ndHAL_Delay(0.15);
}

ndint64 TrackProgressVisualMP3 (char *StringID, ndint64 InfoField, char WndHandleVisualMP3) 
//Callback dei pulsanti logici della ProgressBar
{
	int temp;
	temp=(int) (InfoField);
	ndHAL_MEDIA_Pause(&ndMediaObj);
	ndHAL_Delay(0.2);
    ndHAL_MEDIA_GoToSample(&ndMediaObj, (TotalSamples/47*temp));
    ndHAL_Delay(0.2);
    ndHAL_MEDIA_Play(&ndMediaObj, AutoRew);
}

SetVolumeVisualMP3 (float SetVol, int TB_InfoField, char WndHandleVisualMP3)
//Callback richiamata dalla TrackBar del Volume
{
       Volume=(int)SetVol;
       if (Bal<5) ndHAL_SND_SetVolume(ChannelUsed-1, Volume*2, (Volume*Bal/5)*2);
       else if (Bal>5) ndHAL_SND_SetVolume(ChannelUsed-1, (Volume*(10-Bal)/5)*2, Volume*2);
            else ndHAL_SND_SetVolume(ChannelUsed-1, Volume*2, Volume*2);
}


SetBalanceVisualMP3 (float SetBal, int TB_InfoField, char WndHandleVisualMP3)
//Callback richiamata dalla TrackBar del Balance
{
       Bal=(int)SetBal;
       if (Bal<5) ndHAL_SND_SetVolume(ChannelUsed-1, Volume*2, (Volume*Bal/5)*2);
       else if (Bal>5) ndHAL_SND_SetVolume(ChannelUsed-1, (Volume*(10-Bal)/5)*2, Volume*2);
            else ndHAL_SND_SetVolume(ChannelUsed-1, Volume*2, Volume*2);
}

/*
    ---------------------------------------------------------------------------
    Funzioni del WinMenu
    ---------------------------------------------------------------------------
*/

ndint64 OpenVisualMP3(char WndHandleVisualMP3, ndint64 a)
{   
    int i;
    do
    {
        //Richiamo il file manager
        FileManager ("Choose a file", 0, 0, &FileChoosen);
        
        //Carico il file scelto nel FileManager
        ErrRep=ndHAL_MEDIA_LoadFile (&FileChoosen, ChannelUsed, &ndMediaObj, &MediaCallback, 0);
                 
        if (ErrRep!=0) printf ("Failed to load audio file. Error reported %d \n", -ErrRep);
    } while (ErrRep!=0);
    
    //Aumento il contatore del canale audio utilizzato
    ChannelUsed++;
    
    //Carico l'immagine adatta al tipo di file
    ndIMG_InitImage (&TypeFile);
    if (ndMediaObj.Type==MEDIA_TYPE_MP3) 
    {
        ndIMG_LoadImageFromNDFArray (&TypeFile, 51, 51, &TypeFileMP3, NDMGKNB);
        TotalSamples=ndHAL_MEDIA_GetNrSamples(&ndMediaObj);
    }  
    else 
    {
         ndIMG_LoadImageFromNDFArray (&TypeFile, 51, 51, &TypeFileWAV, NDMGKNB);
         TotalSamples=ndMediaObj.WAV_SamplesInTotal;
    };
    ndIMG_ShowImage (&TypeFile, 261, 43, WndHandleVisualMP3, NORENDER);
    
    for (i=1; i<=5; i++) ndCTRL_DeInhibitButton (BtnHandle[i], WndHandleVisualMP3, NORENDER);
    
    //Scrivo il nome del file sull'interfaccia
    fssSplitNameFile(ndMediaObj.NameFile,PathFile,NameFile,ExtFile);
    strncpy ( ndTBOX_GetRowAddr (0, TBoxHandle, WndHandleVisualMP3), NameFile,strlen(NameFile));
    ndTBOX_TextAreaUpdate (TBoxHandle, WndHandleVisualMP3, NORENDER);
    
    XWindowRender(WndHandleVisualMP3);
    return 0;
}

ndint64 CloseVisualMP3(char WndHandleVisualMP3)
//Funzione che chiude il file precedentemente aperto e riporta l'interfaccia alla situazione originaria
{
    ndIMG_InitImage (&TypeFile);
    
    ndHAL_MEDIA_Stop(&ndMediaObj);
    ndHAL_MEDIA_GoToSample (&ndMediaObj, 0);	//Necessario per riportare la riproduzione all'inizio del file
    ndWS_GrPrintLn (145, 42, COLOR_WHITE, COLOR_BLUE, WndHandleVisualMP3, NDKEY_FONT (1) | NORENDER, "00:00:00");			// Scrive il tempo eseguito
    
    //Scarico il file dalla memoria
    ndHAL_MEDIA_UnLoad(&ndMediaObj);
    
    //Carico l'immagine corrispondente a nessun file
    ndIMG_LoadImageFromNDFArray (&TypeFile, 51, 51, &NoFile, NDMGKNB);
    ndIMG_ShowImage (&TypeFile, 261, 43, WndHandleVisualMP3, NORENDER);
    ndTBAR_DrawProgressBar (12, 131, 312, 150, 0, 0, 100, COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, PBAR_NOT_LABEL, WndHandleVisualMP3, NORENDER);
    strncpy ( ndTBOX_GetRowAddr (0, TBoxHandle, WndHandleVisualMP3), " ",1);
    ndTBOX_TextAreaUpdate (TBoxHandle, WndHandleVisualMP3, NORENDER);
    XWindowRender(WndHandleVisualMP3);
}

ndint64 PlayVisualMP3(char WndHandleVisualMP3)
{
    ndHAL_MEDIA_Play(&ndMediaObj, AutoRew);
}

ndint64 StopVisualMP3(char WndHandleVisualMP3)
{
    ndHAL_MEDIA_Stop(&ndMediaObj);
    ndHAL_MEDIA_GoToSample (&ndMediaObj, 0);	//Necessario per riportare la riproduzione all'inizio del file
    ndWS_GrPrintLn (145, 42, COLOR_WHITE, COLOR_BLUE, WndHandleVisualMP3, NDKEY_FONT (1) | NORENDER, "00:00:00");			// Scrive il tempo eseguito
    ndTBAR_DrawProgressBar (12, 131, 312, 150, 0, 0,100, COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, PBAR_NOT_LABEL, WndHandleVisualMP3, NORENDER);		//Aggiorna la progress bar in base al numero di sample eseguiti.     
    XWindowRender(WndHandleVisualMP3);
}

ndint64 PauseVisualMP3(char WndHandleVisualMP3)
{
    ndHAL_MEDIA_Pause(&ndMediaObj);
}



ndint64 OptionVisualMP3(char WndHandleVisualMP3)
//Funzione che apre la finestra contenente le opzioni del programma
{
    if (!MP3Option)
    {
        MP3Option=1;
        char WndHandleLocal;
        WndHandleLocal=ndLP_CreateWindow (100, 50, 280, 90, "Option", COLOR_WHITE, COLOR_BLUE,COLOR_LBLUE, COLOR_WHITE, NO_RESIZEABLE);
        ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandleLocal);    
        ndLP_PutWindowInFirstPlane(WndHandleLocal);
        ndLP_MaximizeWindow (WndHandleLocal);
         
        ndCBOX_CreateCBox (10, 5, "Autorewind", AutoRew_CtrVariable, 0, &AutoRew_CtrVariable, COLOR_LBLUE, &AutoRew_Callback, WndHandleLocal, NORENDER);
        ndWS_GrWriteLn (30, 7, "Repeat Track", COLOR_BLUE, COLOR_LBLUE, WndHandleLocal, NORENDER);
        XWindowRender(WndHandleLocal);
        
        ndProvideMeTheMouse_Until (&YouCanExit, ND_IS_EQUAL, 1, 0, 0);
        //Uscita dall'applicazione e ritorno alla finestra base
        MP3Option=0;
        YouCanExit=0;
        ndLP_DestroyWindow(WndHandleLocal);
    }
}
        


/*
    ---------------------------------------------------------------------------
    Interfaccia grafica
    ---------------------------------------------------------------------------
*/                
                        
//Struttura del WinMenu
void WinMenuVisualMP3(char WndHandleVisualMP3)
{
     ndWMENU_DefineMenuItem (WndHandleVisualMP3, "File", "File", 0, 0, NORENDER);
         ndWMENU_DefineMenuItem (WndHandleVisualMP3, "File.Open", "Open...", ND_CALLBACK_IN_NEW_CONTEXT, &OpenVisualMP3, NORENDER);
         ndWMENU_DefineMenuItem (WndHandleVisualMP3, "File.Close", "Close", 0, &CloseVisualMP3, NORENDER);
         ndWMENU_DefineMenuItem (WndHandleVisualMP3, "File.Quit", "Quit", 0, &TheCloseWndCallback, NORENDER);
         
     ndWMENU_DefineMenuItem (WndHandleVisualMP3, "Command", "Command", 0, 0, NORENDER);
         ndWMENU_DefineMenuItem (WndHandleVisualMP3, "Command.Play", "Play", 0, &PlayVisualMP3, NORENDER);
         ndWMENU_DefineMenuItem (WndHandleVisualMP3, "Command.Pause", "Pause", 0, &PauseVisualMP3, NORENDER);
         ndWMENU_DefineMenuItem (WndHandleVisualMP3, "Command.Stop", "Stop", 0, &StopVisualMP3, NORENDER);
         ndWMENU_DefineMenuItem (WndHandleVisualMP3, "Command.Option", "Option...", ND_CALLBACK_IN_NEW_CONTEXT, &OptionVisualMP3, NORENDER);
         
     ndWMENU_DefineMenuItem (WndHandleVisualMP3, "?", "?", ND_CALLBACK_IN_NEW_CONTEXT, &AboutVisualApplication, NORENDER); 
}


void InterfacciaVisualMP3(char WndHandleVisualMP3)
//Interfaccia (richiama anche i WinMenu)
{
    int i=0;
    static char StringBufferA [15];
    static char StringBufferB [3];
    
    //Carico i WinMenu
    WinMenuVisualMP3(WndHandleVisualMP3);
    
    //Carico le immagini e creo i rispettivi pulsanti per le funzioni di controllo
    ndIMG_InitImage(&ButtonImage);
    
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 19, 12, &rew, NDMGKNB);
    BtnHandle[4]=ndCTRL_CreateButtonComplex (12, 79, 49, 98, WndHandleVisualMP3, "Rew", "", "", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 0, 0, 0, 0, &ButtonImage, 9, 3, 28, 15, ND_BUTTON_ROUNDED|ND_BUTTON_INHIBITED, &ButtonVisualMP3, 00000004, NORENDER);    
    
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 13, 13, &pause, NDMGKNB);
    BtnHandle[3]=ndCTRL_CreateButtonComplex (12, 58, 49, 77, WndHandleVisualMP3, "Pause", "", "", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 0, 0, 0, 0, &ButtonImage, 12, 3, 25, 16, ND_BUTTON_ROUNDED|ND_BUTTON_INHIBITED, &ButtonVisualMP3, 00000002, NORENDER);    
    
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 12, 15, &play, NDMGKNB);
    BtnHandle[1]=ndCTRL_CreateButtonComplex (12, 37, 93, 56, WndHandleVisualMP3, "Play", "", "", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 0, 0, 0, 0, &ButtonImage, 34, 2, 46, 17, ND_BUTTON_ROUNDED|ND_BUTTON_INHIBITED, &ButtonVisualMP3, 00000000, NORENDER);    
    
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 13, 13, &stop, NDMGKNB);
    BtnHandle[2]=ndCTRL_CreateButtonComplex (52, 58, 93, 77, WndHandleVisualMP3, "Stop", "", "", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 0, 0, 0, 0, &ButtonImage, 12, 3, 25, 16, ND_BUTTON_ROUNDED|ND_BUTTON_INHIBITED, &ButtonVisualMP3, 00000001, NORENDER);    
    
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 19, 12, &ffw, NDMGKNB);
    BtnHandle[5]=ndCTRL_CreateButtonComplex (53, 79, 93, 98, WndHandleVisualMP3, "Ffw", "", "", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 0, 0, 0, 0, &ButtonImage, 9, 3, 28, 15, ND_BUTTON_ROUNDED|ND_BUTTON_INHIBITED, &ButtonVisualMP3, 00000003, NORENDER);    
    
    //Carico l'immagine corrispondente a nessun file caricato.
    ndIMG_LoadImageFromNDFArray (&TypeFile, 51, 51, &NoFile, NDMGKNB);
    ndIMG_ShowImage (&TypeFile, 261, 43, WndHandleVisualMP3, NORENDER);
    
    ndCTRL_CreateButton ( 261, 43, 261+51, 43+51, WndHandleVisualMP3, "OpenButton","", "", COLOR_RED, COLOR_RED, COLOR_RED, ND_BUTTON_LOGIC_MODE|ND_CALLBACK_IN_NEW_CONTEXT, &OpenButtonVisualMP3, 00000000, NORENDER);    
    
    //Rettangolo dove dovr apparire il grafico    
    ndWS_DrawRectangle (98, 37, 257, 98, COLOR_BLUE, COLOR_WHITE, WndHandleVisualMP3, NORENDER);
    
    //Creo il contatore per il tempo di esecuzione
    ndWS_GrPrintLn (145, 42, COLOR_WHITE, COLOR_BLUE, WndHandleVisualMP3, NDKEY_FONT (1) | NORENDER, "00:00:00");
    
    //Creo la textbox che conterr il nome del file caricato
    TBoxHandle = ndTBOX_CreateTextArea(12,6,312,33,"NameBox", NDKEY_SETTEXTAREA (35, 2) | ND_TEXTAREA_INHIBITED | NDKEY_FONT (1), 0, COLOR_BLUE, COLOR_LBLUE, COLOR_BLUE, COLOR_LBLUE, COLOR_BLUE, COLOR_LBLUE, NULL, NULL, NULL, 0, WndHandleVisualMP3, NORENDER);
    ndCTRL_CreateButton ( 12, 6, 312, 33, WndHandleVisualMP3, "OpenNameButton","", "", COLOR_RED, COLOR_RED, COLOR_RED, ND_BUTTON_LOGIC_MODE|ND_CALLBACK_IN_NEW_CONTEXT, &OpenButtonVisualMP3, 00000000, NORENDER);    
    
    //Creo la ProgressBar che indicher il procedere dell'esecuzione del file
    ndTBAR_DrawProgressBar (12, 131, 312, 150, 0, 0, 100, COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, PBAR_NOT_LABEL, WndHandleVisualMP3, NORENDER);

    //Creo la TrackBar per il volume   
    ndTBAR_CreateTrackBar (12, 103, 162, 125,COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, COLOR_LBLUE, COLOR_WHITE, Volume, 0, 50, NDKEY_FONT (1), &SetVolumeVisualMP3, 0,WndHandleVisualMP3,NORENDER);

    //Creo la TrackBar per il balance   
    ndTBAR_CreateTrackBar (162, 103, 312, 125,COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, COLOR_LBLUE, COLOR_WHITE, Bal, 0, 10, NDKEY_FONT (1), &SetBalanceVisualMP3, 0,WndHandleVisualMP3,NORENDER);

    //Creo i pulsanti logici per rendere la ProgressBar precedente capace di portare l'esecuzione al punto selezionato col mouse
    for (i=0; i<51; i++)
    {
        strcpy (StringBufferA, "ProgressBarButton");
        _itoa (i, StringBufferB, 10);
        strcat (StringBufferA, StringBufferB);
        
        ndCTRL_CreateButton ( i*6+12, 131, i*6+18, 150, WndHandleVisualMP3, StringBufferA,"", "", COLOR_RED, COLOR_RED, COLOR_RED, ND_BUTTON_LOGIC_MODE, &TrackProgressVisualMP3, 00000000+i, NORENDER);    
    }

    ndHAL_SND_SetVolume (ChannelUsed-1, Volume*2, Volume*2);
    XWindowRender(WndHandleVisualMP3);
}    


/*
    ---------------------------------------------------------------------------
    Main
    ---------------------------------------------------------------------------
*/ 

void VisualMP3(char *StringID, ndint64 InfoField, char WndHandle)
{
    ndLP_MinimizeWindow (WndHandle);
    WndHandleVisualMP3=ndLP_CreateWindow (2, 2, 324, 195, "VisualMP3", COLOR_WHITE, COLOR_BLUE,COLOR_LBLUE, COLOR_WHITE, NO_RESIZEABLE|MENUSUPPORTED);
    ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandleVisualMP3);    
    ndLP_PutWindowInFirstPlane(WndHandleVisualMP3);
    ndLP_MaximizeWindow (WndHandleVisualMP3);
    ndMediaObj.Type=-1;
    
    InterfacciaVisualMP3(WndHandleVisualMP3);
    ndHAL_MouseControlledByAnalog(AnalogMouse);    
    ndProvideMeTheMouse_Until (&YouCanExit, ND_IS_EQUAL, 1, 0, 0); 
    
    //Uscita dall'applicazione e ritorno alla finestra base
    //Scarico il file dalla memoria
    if (ndMediaObj.Type>-1) {ndHAL_MEDIA_UnLoad(&ndMediaObj);}
    YouCanExit=0;
    ndHAL_Delay(0.5);
    ndLP_DestroyWindow(WndHandleVisualMP3);
    ndLP_MaximizeWindow(WndHandle);
};
