/*
--------------------------------------------------------------------------------------
    VisualApplication v. 0.3
    Copyright (C) 2008 andbad
    andbad@iol.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
--------------------------------------------------------------------------------------
*/
#define ND_NOT_MAIN_SOURCE

#include <nanodesktop.h>
#include "flite.h"

//Dichiarazione delle funzioni globali
ndint64 TheCloseWndCallback (char WndHandle, ndint64 WndInfoField);
ndint64 AboutVisualApplication(char WndHandle);


//Variabili del programma
cst_voice *register_cmu_us_kal();
cst_voice *v;

int BtnHandle, TxtHandle, YouCanExit, AnalogMouse;
char WndHandleT2Speech;
static char Message [255];



/*
    ---------------------------------------------------------------------------
    Callback
    ---------------------------------------------------------------------------
*/
void cbProcessValueAfter (void *ProcessValueData, void *TextData, int TextBoxHandle, char TextBoxWndHandle)
//Funzione che deinibisce il pulsante Speak nel momento in cui viene inserito almeno un carattere nella TextBox
{
     ndCTRL_DeInhibitButton (BtnHandle, WndHandleT2Speech, RENDER);     
}


ndint64 cbSpeak (char *StringID, ndint64 InfoField, char WndHandleT2Speech)
//Funzione che fa riprodurre la/e parola/e inserite nella TextBox
{
    ndWS_GrWriteLn (30, 80, "Waiting....", COLOR_BLUE, COLOR_LBLUE, WndHandleT2Speech, RENDER);
    flite_text_to_speech (Message,v,"play");
    ndWS_DrawRectangle (10, 78, 240, 92, COLOR_LBLUE, COLOR_LBLUE, WndHandleT2Speech, RENDER);   
}



/*
    ---------------------------------------------------------------------------
    Interfaccia grafica
    ---------------------------------------------------------------------------
*/
void InterfacciaT2Speech (int WndHandleT2Speech)
{
    struct ndEvent_Type Evento;    
   
    ndWS_GrWriteLn (10, 15, "Type a message in the text box", COLOR_BLUE, COLOR_LBLUE, WndHandleT2Speech, NORENDER);
   
    TxtHandle = ndTBOX_CreateTextArea (10, 30, 300, 50, "Text area 0", NDKEY_FONT (3) | NDKEY_SETTEXTAREA (255, 1), &Message,
                                   COLOR_BLUE, COLOR_LBLUE,
                                   COLOR_BLUE, COLOR_LBLUE,
                                   COLOR_BLUE, COLOR_LBLUE,
                                   0, 0, &cbProcessValueAfter,
                                   0, WndHandleT2Speech, NORENDER);
                                   
    BtnHandle = ndCTRL_CreateButton (250, 60, 300, 90, WndHandleT2Speech, "Speak", "Speak", "", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, ND_BUTTON_ROUNDED | ND_BUTTON_INHIBITED, &cbSpeak, 0, NORENDER);
    XWindowRender(WndHandleT2Speech);   
}

/*
    ---------------------------------------------------------------------------
    Main
    ---------------------------------------------------------------------------
*/
void VisualT2Speech(char *StringID, ndint64 InfoField, char WndHandle)
{
    int Counter;
    ndInitSystem ();
   
    flite_init();
    v = register_cmu_us_kal ();
    memset (&Message, 0, 255);
    
    ndLP_MinimizeWindow(WndHandle);
    WndHandleT2Speech = ndLP_AllocateWindow (1, 1, 331, 141, "T2Speech", COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE);
    ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandleT2Speech);
    ndLP_PutWindowInFirstPlane(WndHandleT2Speech);
    ndLP_MaximizeWindow (WndHandleT2Speech);
    
    InterfacciaT2Speech(WndHandleT2Speech);
    ndHAL_MouseControlledByAnalog(AnalogMouse);
    ndProvideMeTheMouse_Until (&YouCanExit, ND_IS_EQUAL, 1, 0, 0);
    
    //Uscita dall'applicazione e ritorno alla finestra base
    YouCanExit=0;
    ndHAL_Delay(0.5);
    ndLP_DestroyWindow(WndHandleT2Speech);
    ndLP_MaximizeWindow(WndHandle); 
} 
