/*
--------------------------------------------------------------------------------------
    VisualApplication v. 0.3
    Copyright (C) 2008 andbad
    andbad@iol.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
--------------------------------------------------------------------------------------
*/
#define ND_DISABLE_NETWORK_SERVICES
#define ND_DISABLE_USB_SERVICES
#define ND_DISABLE_RAWIR_SERVER

#include <nanodesktop.h>
#include <stdio.h>

int YouCanExit=0,AboutVisualApplicationExist=0,ChangeBGVisualApplicationExist=0,ErrRep, AnalogMouse=0;

    
//Prototipi delle funzioni delle applicazioni
void VisualCalc(char *StringID, ndint64 InfoField, char WndHandle);
void VisualMP3(char *StringID, ndint64 InfoField, char WndHandle);
void VisualT2Speech(char *StringID, ndint64 InfoField, char WndHandle);
void VisualOCR(char *StringID, ndint64 InfoField, char WndHandle);
void VisualFileManager(char *StringID, ndint64 InfoField, char WndHandle);


/*
    ---------------------------------------------------------------------------
    Callback varie
    ---------------------------------------------------------------------------
*/
ndint64 TheCloseWndCallback (char WndHandle, ndint64 WndInfoField)
{
     YouCanExit=1;
     ndHAL_Delay(0.5);
} 

ndint64 AboutVisualApplication(char WndHandle)
//Finestra dei credits del programma
{       
    if (!AboutVisualApplicationExist)
    {
        AboutVisualApplicationExist=1;
        char WndHandleLocal;
        WndHandleLocal=ndLP_CreateWindow (100, 50, 250, 130, "About", COLOR_WHITE, COLOR_LBLUE,COLOR_BLACK, COLOR_WHITE, NO_RESIZEABLE);
        ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandleLocal);    
        ndLP_PutWindowInFirstPlane(WndHandleLocal);
        ndLP_MaximizeWindow (WndHandleLocal);
         
        ndWS_GrPrintLn (14, 5, COLOR_WHITE, COLOR_BLACK, WndHandleLocal, NDKEY_FONT (3) | NORENDER,  " Copyright of ");
        ndWS_GrPrintLn (14, 15, COLOR_WHITE, COLOR_BLACK, WndHandleLocal, NDKEY_FONT (3) | NORENDER, "    andbad    ");
        ndWS_GrPrintLn (14, 25, COLOR_WHITE, COLOR_BLACK, WndHandleLocal, NDKEY_FONT (3) | NORENDER, "on NanoDesktop");
        ndWS_GrPrintLn (14, 35, COLOR_WHITE, COLOR_BLACK, WndHandleLocal, NDKEY_FONT (3) | NORENDER, "  technology  ");
        ndWS_GrPrintLn (14, 45, COLOR_WHITE, COLOR_BLACK, WndHandleLocal, NDKEY_FONT (3) | NORENDER, "   Ver. 0.3   ");
        XWindowRender(WndHandleLocal);
        
        ndProvideMeTheMouse_Until (&YouCanExit, ND_IS_EQUAL, 1, 0, 0);
        //Uscita dall'applicazione e ritorno alla finestra base
        AboutVisualApplicationExist=0;
        YouCanExit=0;
        ndHAL_Delay(0.5);
        ndLP_DestroyWindow(WndHandleLocal);
        ndLP_MaximizeWindow(WndHandle);
    };
}

ndint64 ChangeBGVisualApplication(char WndHandle)
//Funzione per cambiare il background del BaseScreen.
{       
    if (!ChangeBGVisualApplicationExist)
    {
        char FileChoosen[255];
        ChangeBGVisualApplicationExist=1;
        
	    //Richiamo il FileManager per selezionare un file immagine
        FileManager ("Choose a image file for Backgroud", 0, 0, FileChoosen);
    
        ErrRep=ndLP_LoadWallPaperFromFile (&FileChoosen);
        if (ErrRep) 
        {
             printf ("Failed to load image file. Error reported %d \n", -ErrRep);        
        };
        
        ChangeBGVisualApplicationExist=0;
    };
    ndHAL_Delay(0.15);
}

ndint64 ChangeAnalogDigitalMouse(char WndHndle)
//Funzione per abilitare il controllo del puntatore con l'analogico o con i tasti direzione
{
    AnalogMouse=(!AnalogMouse);
    ndHAL_MouseControlledByAnalog(AnalogMouse);
    ndProvideMeTheMouse_Until (&YouCanExit, ND_IS_EQUAL, 1, 0, 0);
}
       
/*
    ---------------------------------------------------------------------------
    Interfaccia grafica
    ---------------------------------------------------------------------------
*/

void WinMenuVisualApplication(char WndHandle)
//Struttura del WinMenu
{
     ndWMENU_DefineMenuItem (WndHandle, "File", "File", 0, 0, NORENDER);
         ndWMENU_DefineMenuItem (WndHandle, "File.RunCalc", "VisualCalculator", ND_CALLBACK_IN_NEW_CONTEXT, &VisualCalc, NORENDER);
         ndWMENU_DefineMenuItem (WndHandle, "File.RunPlayer", "VisualMP3", ND_CALLBACK_IN_NEW_CONTEXT, &VisualMP3, NORENDER);
         ndWMENU_DefineMenuItem (WndHandle, "File.RunT2Speech", "VisualT2Speech", ND_CALLBACK_IN_NEW_CONTEXT, &VisualT2Speech, NORENDER);
	 ndWMENU_DefineMenuItem (WndHandle, "File.RunOCR", "VisualOCR", ND_CALLBACK_IN_NEW_CONTEXT, &VisualOCR, NORENDER);
	 ndWMENU_DefineMenuItem (WndHandle, "File.RunFileManager", "VisualFM", ND_CALLBACK_IN_NEW_CONTEXT, &VisualFileManager, NORENDER);
         ndWMENU_DefineMenuItem (WndHandle, "File.Quit", "Quit", 0, &TheCloseWndCallback, NORENDER);        
     ndWMENU_DefineMenuItem (WndHandle, "Option", "Option", ND_CALLBACK_IN_NEW_CONTEXT, 0, NORENDER);    
          ndWMENU_DefineMenuItem (WndHandle, "Option.Background", "Change Background...", ND_CALLBACK_IN_NEW_CONTEXT, &ChangeBGVisualApplication, NORENDER);         
          ndWMENU_DefineMenuItem (WndHandle, "Option.AnalogMouse", "Analog/Digital Mouse", ND_CALLBACK_IN_NEW_CONTEXT, &ChangeAnalogDigitalMouse, NORENDER);         
                  
     ndWMENU_DefineMenuItem (WndHandle, "?", "?", ND_CALLBACK_IN_NEW_CONTEXT, &AboutVisualApplication, NORENDER);    
}

void InterfacciaMain(char WndHandle)
{
    struct ndImage_Type ButtonImage;
    extern unsigned short int T2SpeechImg,VisualCalculatorImg,VisualMP3Img,VisualOCRImage,VisualFMImage;
    
    //Carico i WinMenu
    WinMenuVisualApplication(WndHandle);
    
    //Creo le icone delle applicazioni
    ndIMG_InitImage(&ButtonImage);
    
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 30, 17, &VisualMP3Img, NDMGKNB);
    ndCTRL_CreateButtonComplex (10, 10, 90, 65, WndHandle, "VisualMP3", "Visual", "MP3", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 5, 37, 75, 45, &ButtonImage, 25, 7, 55, 24, ND_BUTTON_ROUNDED|ND_CALLBACK_IN_NEW_CONTEXT, &VisualMP3, 0, NORENDER);
    
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 30, 21, &VisualCalculatorImg, NDMGKNB);
    ndCTRL_CreateButtonComplex (100, 10, 180, 65, WndHandle, "VisualCalculator", "Visual", "Calc", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 5, 37, 75, 45, &ButtonImage, 25, 7, 55, 28, ND_BUTTON_ROUNDED|ND_CALLBACK_IN_NEW_CONTEXT, &VisualCalc, 0, NORENDER);
    
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 30, 20, &T2SpeechImg, NDMGKNB);
    ndCTRL_CreateButtonComplex (190, 10, 270, 65, WndHandle, "VisualT2Speech", "Visual", "T2Speech", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 5, 37, 75, 45, &ButtonImage, 25, 7, 55, 27, ND_BUTTON_ROUNDED|ND_CALLBACK_IN_NEW_CONTEXT, &VisualT2Speech, 0, NORENDER);
        
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 30, 20, &VisualOCRImage, NDMGKNB);
    ndCTRL_CreateButtonComplex (280, 10, 360, 65, WndHandle, "VisualOCR", "Visual", "OCR", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 5, 37, 75, 45, &ButtonImage, 25, 7, 55, 27, ND_BUTTON_ROUNDED|ND_CALLBACK_IN_NEW_CONTEXT, &VisualOCR, 0, NORENDER);
    
    ndIMG_LoadImageFromNDFArray (&ButtonImage, 30, 27, &VisualFMImage, NDMGKNB);
    ndCTRL_CreateButtonComplex (10, 75, 90, 130, WndHandle, "VisualFM", "Visual", "FM", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 5, 37, 75, 45, &ButtonImage, 25, 7, 55, 27, ND_BUTTON_ROUNDED|ND_CALLBACK_IN_NEW_CONTEXT, &VisualFileManager, 0, NORENDER);
    
    XWindowRender(WndHandle);
}


/*
    ---------------------------------------------------------------------------
    Main
    ---------------------------------------------------------------------------
*/
ndMain ()
{
    int WndHandle;
    extern unsigned short int Sfondo;
    struct ndImage_Type WallPaper;
    ndInitSystem();
    
    //Carico lo Sfondo.
    ndIMG_InitImage(&WallPaper);
    ndIMG_LoadImageFromNDFArray (&WallPaper, 480, 272, &Sfondo, NDMGKNB);
    ndLP_LoadWallPaperFromNDImage(&WallPaper);
    
    //Creazione finestra base
    WndHandle=ndLP_CreateWindow (1, 1, 380, 190, "VisualApplication 0.3", COLOR_WHITE, COLOR_BLUE,COLOR_LBLUE, COLOR_WHITE, MENUSUPPORTED);
    ndLP_PutWindowInFirstPlane(WndHandle);
    ndLP_MaximizeWindow (WndHandle);
    ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandle);
    ndLP_EnableTrasparency();
    
    InterfacciaMain(WndHandle);
    ndHAL_MouseControlledByAnalog(AnalogMouse);
    ndProvideMeTheMouse_Until (&YouCanExit, ND_IS_EQUAL, 1, 0, 0);
    
    ndLP_DestroyWindow(WndHandle);
    ndHAL_SystemHalt (0);
}
